function particles = load_all_distributions(modelname, nparticles, idparam)

% (C) Stéphane Adjemian 2024

n = number_of_smc_files(modelname);

particles = NaN(nparticles, n);

for i=1:n
    p = load(sprintf('%s%shssmc%sparticles-%u-%u.mat', modelname, filesep, filesep, i, n));
    if isfield(p, 'weights')
        iresample = kitagawa(p.weights);
        p.particles = p.particles(:,iresample);
    end
    particles(:,i) = transpose(p.particles(idparam,:));
end
